/* See LICENSE file for copyright and license details. */

#include <stdio.h>
#include <stdlib.h>

#include "../headers/file.h"

#define BUF_SIZE 1024

File
*new_file(char *file_name)
{
	File *f;
	
	if ((f = malloc(sizeof(File))) == NULL) {
		fprintf(stderr, "memory for file was not allocated.\n");
		exit(EXIT_FAILURE);
	}

	f->file_name = file_name;
	//fprintf(stderr, "%s\n", f->file_name);

	if ((f->file = fopen(f->file_name, "r")) == NULL) {
		fprintf(stderr, "file %s was not opened.\n",
				f->file_name);
		exit(EXIT_FAILURE);
	}

	return f;
}

void
free_file(File *f)
{
	if (fclose(f->file) == EOF) {
		fprintf(stderr, "file %s was not closed.\n",
				f->file_name);
		exit(EXIT_FAILURE);
	}
	free(f);
}

double
get_entry(File *f, int row, int col, char sep)
{
	int i;
	char buf[BUF_SIZE];
	double x;

	rewind(f->file);

	for (i=0; i<row; i++)
		fgets(buf, BUF_SIZE, f->file);

	for (i=0; i<col; i++) {
		while (fgetc(f->file) != sep)
			;
	}

	fscanf(f->file, "%lf", &x);
	return x;
}

int
get_columns_num(File *f, int row, char sep)
{
	int i, count;
	char c, buf[BUF_SIZE];

	c = '0';
	count = 1;
	rewind(f->file);

	for (i=0; i<row; i++)
		fgets(buf, BUF_SIZE, f->file);

	while (c != '\n') {
		c = fgetc(f->file);
		if (c == sep)
			count++;
	}

	return count;
}

int
get_rows_num(File *f)
{
	char buf[BUF_SIZE];
	int count;

	count = 0;
	rewind(f->file);

	while (fgets(buf, BUF_SIZE, f->file))
		count++;

	return count;
}
