/* See LICENSE file for copyright and license details. */

#include <stdio.h>
#include <stdlib.h>

#include "../headers/layer.h"

Layer
*new_layer(int p_num, int i_num)
{
	int i;
	Layer *l;

	l = malloc(sizeof(Layer));

	l->p_num = p_num;

	l->p = calloc(l->p_num, sizeof(Perceptron *));

	for (i=0; i<l->p_num; i++) {
		l->p[i] = new_perceptron(i_num);
	}
	
	if (l==NULL || l->p==NULL) {
		fprintf(stderr, "memory for layer was not allocated.\n");
		exit(EXIT_FAILURE);
	}

	return l;
}

Layer
*new_input_layer(int p_num)
{
	int i;
	Layer *l;

	l = malloc(sizeof(Layer));

	l->p_num = p_num;

	l->p = calloc(l->p_num, sizeof(Perceptron *));

	for (i=0; i<l->p_num; i++) {
		l->p[i] = new_perceptron(1);
	}

	if (l==NULL || l->p==NULL) {
		fprintf(stderr, "memory for layer was not allocated.\n");
		exit(EXIT_FAILURE);
	}

	return l;
}

void
free_layer(Layer *l)
{
	int i;

	for (i=0; i<l->p_num; i++) {
		free_perceptron(l->p[i]);
	}
	free(l->p);
	free(l);
}
