/* See LICENSE file for copyright and license details. */

#include <stdio.h>
#include <stdlib.h>

#include "../headers/file.h"
#include "../headers/neural_net.h"

NeuralNet
*new_neural_net(char *c_file_name, char *i_file_name)
{
	int i;
	NeuralNet *n;
	File *c_file = new_file(c_file_name);
	File *i_file = new_file(i_file_name);

	n = malloc(sizeof(NeuralNet));
	n->l_num = get_columns_num(c_file, 0, ',');
	n->l     = calloc(n->l_num, sizeof(Layer *));
	int p_num[n->l_num];
	int i_num[n->l_num];

	for (i=0; i<n->l_num-1; i++) {
		p_num[i] = get_entry(c_file, 0, i, ',') + 1;
	}
	p_num[n->l_num-1] = get_entry(c_file, 0, n->l_num-1, ',');

	i_num[0] = get_columns_num(i_file, 0, ',');
	for (i=1; i<n->l_num; i++) {
		i_num[i] = p_num[i-1];
	}

	free_file(c_file);
	free_file(i_file);

	n->l[0] = new_input_layer(p_num[0]);
	for (i=1; i<n->l_num; i++) {
		n->l[i] = new_layer(p_num[i], i_num[i]);
	}

	if (n==NULL || n->l==NULL) {
		fprintf(stderr, "memory for neural net was not allocated.\n");
		exit(EXIT_FAILURE);
	}

	return n;
}

void
free_neural_net(NeuralNet *n)
{
	int i;

	for (i=0; i<n->l_num; i++) {
		free_layer(n->l[i]);
	}
	free(n->l);
	free(n);
}
